Blame tests/run-debuginfod-find.sh

Packit 032894
#!/bin/bash
Packit 032894
#
Packit 032894
# Copyright (C) 2019 Red Hat, Inc.
Packit 032894
# This file is part of elfutils.
Packit 032894
#
Packit 032894
# This file is free software; you can redistribute it and/or modify
Packit 032894
# it under the terms of the GNU General Public License as published by
Packit 032894
# the Free Software Foundation; either version 3 of the License, or
Packit 032894
# (at your option) any later version.
Packit 032894
#
Packit 032894
# elfutils is distributed in the hope that it will be useful, but
Packit 032894
# WITHOUT ANY WARRANTY; without even the implied warranty of
Packit 032894
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Packit 032894
# GNU General Public License for more details.
Packit 032894
#
Packit 032894
# You should have received a copy of the GNU General Public License
Packit 032894
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
Packit 032894
Packit 032894
. $srcdir/test-subr.sh  # includes set -e
Packit 032894
Packit 032894
DB=${PWD}/.debuginfod_tmp.sqlite
Packit 032894
tempfiles $DB
Packit 032894
export DEBUGINFOD_CACHE_PATH=${PWD}/.client_cache
Packit 032894
Packit 032894
PID1=0
Packit 032894
PID2=0
Packit 032894
Packit 032894
cleanup()
Packit 032894
{
Packit 032894
  if [ $PID1 -ne 0 ]; then kill $PID1; wait $PID1; fi
Packit 032894
  if [ $PID2 -ne 0 ]; then kill $PID2; wait $PID2; fi
Packit 032894
Packit 032894
  rm -rf F R L ${PWD}/.client_cache*
Packit 032894
  exit_cleanup
Packit 032894
}
Packit 032894
Packit 032894
# clean up trash if we were aborted early
Packit 032894
trap cleanup 0 1 2 3 5 9 15
Packit 032894
Packit 032894
# find an unused port number
Packit 032894
while true; do
Packit 032894
    PORT1=`expr '(' $RANDOM % 1000 ')' + 9000`
Packit 032894
    ss -atn | fgrep ":$PORT1" || break
Packit 032894
done    
Packit 032894
Packit 032894
# We want to run debuginfod in the background.  We also want to start
Packit 032894
# it with the same check/installcheck-sensitive LD_LIBRARY_PATH stuff
Packit 032894
# that the testrun alias sets.  But: we if we just use
Packit 032894
#    testrun .../debuginfod
Packit 032894
# it runs in a subshell, with different pid, so not helpful.
Packit 032894
#
Packit 032894
# So we gather the LD_LIBRARY_PATH with this cunning trick:
Packit 032894
ldpath=`testrun sh -c 'echo $LD_LIBRARY_PATH'`
Packit 032894
Packit 032894
mkdir F R L
Packit 032894
# not tempfiles F R L - they are directories which we clean up manually
Packit 032894
ln -s ${abs_builddir}/dwfllines L/foo   # any program not used elsewhere in this test
Packit 032894
Packit 032894
wait_ready()
Packit 032894
{
Packit 032894
  port=$1;
Packit 032894
  what=$2;
Packit 032894
  value=$3;
Packit 032894
  timeout=20;
Packit 032894
Packit 032894
  echo "Wait $timeout seconds on $port for metric $what to change to $value"
Packit 032894
  while [ $timeout -gt 0 ]; do
Packit 032894
    mvalue="$(curl -s http://127.0.0.1:$port/metrics \
Packit 032894
              | grep "$what" | awk '{print $NF}')"
Packit 032894
    if [ -z "$mvalue" ]; then mvalue=0; fi
Packit 032894
      echo "metric $what: $mvalue"
Packit 032894
      if [ "$mvalue" -eq "$value" ]; then
Packit 032894
        break;
Packit 032894
    fi
Packit 032894
    sleep 0.5;
Packit 032894
    ((timeout--));
Packit 032894
  done;
Packit 032894
Packit 032894
  if [ $timeout -eq 0 ]; then
Packit 032894
    echo "metric $what never changed to $value on port $port"
Packit 032894
    exit 1;
Packit 032894
  fi
Packit 032894
}
Packit 032894
Packit 032894
env LD_LIBRARY_PATH=$ldpath DEBUGINFOD_URLS= ${abs_builddir}/../debuginfod/debuginfod -F -R -d $DB -p $PORT1 -t0 -g0 R F L &
Packit 032894
PID1=$!
Packit 032894
# Server must become ready
Packit 032894
wait_ready $PORT1 'ready' 1
Packit 032894
export DEBUGINFOD_URLS=http://127.0.0.1:$PORT1/   # or without trailing /
Packit 032894
Packit 032894
# Be patient when run on a busy machine things might take a bit.
Packit 032894
export DEBUGINFOD_TIMEOUT=10
Packit 032894
Packit 032894
# We use -t0 and -g0 here to turn off time-based scanning & grooming.
Packit 032894
# For testing purposes, we just sic SIGUSR1 / SIGUSR2 at the process.
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Compile a simple program, strip its debuginfo and save the build-id.
Packit 032894
# Also move the debuginfo into another directory so that elfutils
Packit 032894
# cannot find it without debuginfod.
Packit 032894
echo "int main() { return 0; }" > ${PWD}/prog.c
Packit 032894
tempfiles prog.c
Packit 032894
gcc -g -o prog ${PWD}/prog.c
Packit 032894
 ${abs_top_builddir}/src/strip -g -f prog.debug ${PWD}/prog
Packit 032894
BUILDID=`env LD_LIBRARY_PATH=$ldpath ${abs_builddir}/../src/readelf \
Packit 032894
          -a prog | grep 'Build ID' | cut -d ' ' -f 7`
Packit 032894
Packit 032894
mv prog F
Packit 032894
mv prog.debug F
Packit 032894
kill -USR1 $PID1
Packit 032894
# Wait till both files are in the index.
Packit 032894
wait_ready $PORT1 'thread_work_total{file="F"}' 2
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Test whether elfutils, via the debuginfod client library dlopen hooks,
Packit 032894
# is able to fetch debuginfo from the local debuginfod.
Packit 032894
testrun ${abs_builddir}/debuginfod_build_id_find -e F/prog 1
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Test whether debuginfod-find is able to fetch those files.
Packit 032894
rm -rf $DEBUGINFOD_CACHE_PATH # clean it from previous tests
Packit 032894
filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find debuginfo $BUILDID`
Packit 032894
cmp $filename F/prog.debug
Packit 032894
Packit 032894
filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find executable $BUILDID`
Packit 032894
cmp $filename F/prog
Packit 032894
Packit 032894
filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find source $BUILDID ${PWD}/prog.c`
Packit 032894
cmp $filename  ${PWD}/prog.c
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Add artifacts to the search paths and test whether debuginfod finds them while already running.
Packit 032894
Packit 032894
# Build another, non-stripped binary
Packit 032894
echo "int main() { return 0; }" > ${PWD}/prog2.c
Packit 032894
tempfiles prog2.c
Packit 032894
gcc -g -o prog2 ${PWD}/prog2.c
Packit 032894
BUILDID2=`env LD_LIBRARY_PATH=$ldpath ${abs_builddir}/../src/readelf \
Packit 032894
          -a prog2 | grep 'Build ID' | cut -d ' ' -f 7`
Packit 032894
Packit 032894
mv prog2 F
Packit 032894
kill -USR1 $PID1
Packit 032894
# Now there should be 3 files in the index
Packit 032894
wait_ready $PORT1 'thread_work_total{file="F"}' 3
Packit 032894
Packit 032894
# Rerun same tests for the prog2 binary
Packit 032894
filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find -v debuginfo $BUILDID2 2>vlog`
Packit 032894
cmp $filename F/prog2
Packit 032894
cat vlog
Packit 032894
grep -q Progress vlog
Packit 032894
tempfiles vlog
Packit 86a02d
filename=`testrun env DEBUGINFOD_PROGRESS=1 ${abs_top_builddir}/debuginfod/debuginfod-find executable $BUILDID2 2>vlog2`
Packit 032894
cmp $filename F/prog2
Packit 86a02d
cat vlog2
Packit 86a02d
grep -q Downloading vlog2
Packit 86a02d
tempfiles vlog2
Packit 032894
filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find source $BUILDID2 ${PWD}/prog2.c`
Packit 032894
cmp $filename ${PWD}/prog2.c
Packit 032894
Packit 032894
cp -rp ${abs_srcdir}/debuginfod-rpms R
Packit 032894
kill -USR1 $PID1
Packit 032894
# All rpms need to be in the index
Packit 032894
rpms=$(find R -name \*rpm | wc -l)
Packit 032894
wait_ready $PORT1 'scanned_total{source="rpm"}' $rpms
Packit 032894
Packit 032894
kill -USR1 $PID1  # two hits of SIGUSR1 may be needed to resolve .debug->dwz->srefs
Packit 032894
# Expect all source files found in the rpms (they are all called hello.c :)
Packit 032894
# We will need to extract all rpms (in their own directory) and could all
Packit 032894
# sources referenced in the .debug files.
Packit 032894
mkdir extracted
Packit 032894
cd extracted
Packit 032894
subdir=0;
Packit 032894
newrpms=$(find ../R -name \*\.rpm)
Packit 032894
for i in $newrpms; do
Packit 032894
    subdir=$[$subdir+1];
Packit 032894
    mkdir $subdir;
Packit 032894
    cd $subdir;
Packit 032894
    ls -lah ../$i
Packit 032894
    rpm2cpio ../$i | cpio -id;
Packit 032894
    cd ..;
Packit 032894
done
Packit 032894
sourcefiles=$(find -name \*\\.debug \
Packit 032894
	      | env LD_LIBRARY_PATH=$ldpath xargs \
Packit 032894
		${abs_top_builddir}/src/readelf --debug-dump=decodedline \
Packit 032894
	      | grep mtime: | wc --lines)
Packit 032894
cd ..
Packit 032894
rm -rf extracted
Packit 032894
Packit 032894
wait_ready $PORT1 'found_sourcerefs_total{source="rpm"}' $sourcefiles
Packit 032894
Packit 032894
# Run a bank of queries against the debuginfod-rpms test cases
Packit 032894
Packit 032894
rpm_test() {
Packit 032894
    __BUILDID=$1
Packit 032894
    __SOURCEPATH=$2
Packit 032894
    __SOURCESHA1=$3
Packit 032894
    
Packit 032894
    filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find executable $__BUILDID`
Packit 032894
    buildid=`env LD_LIBRARY_PATH=$ldpath ${abs_builddir}/../src/readelf \
Packit 032894
             -a $filename | grep 'Build ID' | cut -d ' ' -f 7`
Packit 032894
    test $__BUILDID = $buildid
Packit 032894
Packit 032894
    filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find debuginfo $__BUILDID`
Packit 032894
    buildid=`env LD_LIBRARY_PATH=$ldpath ${abs_builddir}/../src/readelf \
Packit 032894
             -a $filename | grep 'Build ID' | cut -d ' ' -f 7`
Packit 032894
    test $__BUILDID = $buildid
Packit 032894
    
Packit 032894
    filename=`testrun ${abs_top_builddir}/debuginfod/debuginfod-find source $__BUILDID $__SOURCEPATH`
Packit 032894
    hash=`cat $filename | sha1sum | awk '{print $1}'`
Packit 032894
    test $__SOURCESHA1 = $hash
Packit 032894
}
Packit 032894
Packit 032894
Packit 032894
# common source file sha1
Packit 032894
SHA=f4a1a8062be998ae93b8f1cd744a398c6de6dbb1
Packit 032894
# fedora30
Packit 032894
rpm_test c36708a78618d597dee15d0dc989f093ca5f9120 /usr/src/debug/hello2-1.0-2.x86_64/hello.c $SHA
Packit 032894
rpm_test 41a236eb667c362a1c4196018cc4581e09722b1b /usr/src/debug/hello2-1.0-2.x86_64/hello.c $SHA
Packit 032894
# rhel7
Packit 032894
rpm_test bc1febfd03ca05e030f0d205f7659db29f8a4b30 /usr/src/debug/hello-1.0/hello.c $SHA
Packit 032894
rpm_test f0aa15b8aba4f3c28cac3c2a73801fefa644a9f2 /usr/src/debug/hello-1.0/hello.c $SHA
Packit 032894
# rhel6
Packit 032894
rpm_test bbbf92ebee5228310e398609c23c2d7d53f6e2f9 /usr/src/debug/hello-1.0/hello.c $SHA
Packit 032894
rpm_test d44d42cbd7d915bc938c81333a21e355a6022fb7 /usr/src/debug/hello-1.0/hello.c $SHA
Packit 032894
Packit 032894
RPM_BUILDID=d44d42cbd7d915bc938c81333a21e355a6022fb7 # in rhel6/ subdir, for a later test
Packit 032894
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Drop some of the artifacts, run a groom cycle; confirm that
Packit 032894
# debuginfod has forgotten them, but remembers others
Packit 032894
Packit 032894
rm -r R/debuginfod-rpms/rhel6/*
Packit 032894
kill -USR2 $PID1  # groom cycle
Packit 032894
# Expect 3 rpms to be deleted by the groom
Packit 032894
wait_ready $PORT1 'groom{statistic="file d/e"}' 3
Packit 032894
Packit 032894
rm -rf $DEBUGINFOD_CACHE_PATH # clean it from previous tests
Packit 032894
Packit 032894
testrun ${abs_top_builddir}/debuginfod/debuginfod-find executable $RPM_BUILDID && false || true
Packit 032894
Packit 032894
testrun ${abs_top_builddir}/debuginfod/debuginfod-find executable $BUILDID2
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Federation mode
Packit 032894
Packit 032894
# find another unused port
Packit 032894
while true; do
Packit 032894
    PORT2=`expr '(' $RANDOM % 1000 ')' + 9000`
Packit 032894
    ss -atn | fgrep ":$PORT2" || break
Packit 032894
done
Packit 032894
Packit 032894
export DEBUGINFOD_CACHE_PATH=${PWD}/.client_cache2
Packit 032894
mkdir -p $DEBUGINFOD_CACHE_PATH
Packit 032894
# NB: inherits the DEBUGINFOD_URLS to the first server
Packit 032894
# NB: run in -L symlink-following mode for the L subdir
Packit 032894
env LD_LIBRARY_PATH=$ldpath ${abs_builddir}/../debuginfod/debuginfod -F -d ${DB}_2 -p $PORT2 -L L &
Packit 032894
PID2=$!
Packit 032894
tempfiles ${DB}_2
Packit 032894
wait_ready $PORT2 'ready' 1
Packit 032894
Packit 032894
# have clients contact the new server
Packit 032894
export DEBUGINFOD_URLS=http://127.0.0.1:$PORT2
Packit 032894
rm -rf $DEBUGINFOD_CACHE_PATH
Packit 032894
testrun ${abs_top_builddir}/debuginfod/debuginfod-find debuginfo $BUILDID
Packit 032894
Packit 032894
# confirm that first server can't resolve symlinked info in L/ but second can
Packit 032894
BUILDID=`env LD_LIBRARY_PATH=$ldpath ${abs_builddir}/../src/readelf \
Packit 032894
         -a L/foo | grep 'Build ID' | cut -d ' ' -f 7`
Packit 032894
file L/foo
Packit 032894
file -L L/foo
Packit 032894
export DEBUGINFOD_URLS=http://127.0.0.1:$PORT1
Packit 032894
rm -rf $DEBUGINFOD_CACHE_PATH
Packit 032894
testrun ${abs_top_builddir}/debuginfod/debuginfod-find debuginfo $BUILDID && false || true
Packit 032894
export DEBUGINFOD_URLS=http://127.0.0.1:$PORT2
Packit 032894
testrun ${abs_top_builddir}/debuginfod/debuginfod-find debuginfo $BUILDID
Packit 032894
Packit 032894
Packit 032894
# test parallel queries in client
Packit 032894
export DEBUGINFOD_CACHE_PATH=${PWD}/.client_cache3
Packit 032894
mkdir -p $DEBUGINFOD_CACHE_PATH
Packit 032894
export DEBUGINFOD_URLS="BAD http://127.0.0.1:$PORT1 127.0.0.1:$PORT1 http://127.0.0.1:$PORT2 DNE"
Packit 032894
Packit 032894
testrun ${abs_builddir}/debuginfod_build_id_find -e F/prog2 1
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Fetch some metrics, if curl program is installed
Packit 032894
if type curl 2>/dev/null; then
Packit 032894
    curl http://127.0.0.1:$PORT1/badapi
Packit 032894
    curl http://127.0.0.1:$PORT1/metrics
Packit 032894
    curl http://127.0.0.1:$PORT2/metrics
Packit 032894
    curl http://127.0.0.1:$PORT1/metrics | grep -q 'http_responses_total.*result.*error'
Packit 032894
    curl http://127.0.0.1:$PORT2/metrics | grep -q 'http_responses_total.*result.*upstream'
Packit 032894
fi
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Run the tests again without the servers running. The target file should
Packit 032894
# be found in the cache.
Packit 032894
Packit 032894
kill -INT $PID1 $PID2
Packit 032894
wait $PID1 $PID2
Packit 032894
PID1=0
Packit 032894
PID2=0
Packit 032894
tempfiles .debuginfod_*
Packit 032894
Packit 032894
testrun ${abs_builddir}/debuginfod_build_id_find -e F/prog2 1
Packit 032894
Packit 032894
########################################################################
Packit 032894
Packit 032894
# Trigger a cache clean and run the tests again. The clients should be unable to
Packit 032894
# find the target.
Packit 032894
echo 0 > $DEBUGINFOD_CACHE_PATH/cache_clean_interval_s
Packit 032894
echo 0 > $DEBUGINFOD_CACHE_PATH/max_unused_age_s
Packit 032894
Packit 032894
testrun ${abs_builddir}/debuginfod_build_id_find -e F/prog 1
Packit 032894
Packit 032894
testrun ${abs_top_builddir}/debuginfod/debuginfod-find debuginfo $BUILDID2 && false || true
Packit 032894
Packit 032894
exit 0